"======================================================================
|
|   Regular expressions declarations
|
|   $Revision: 1.95.1$
|   $Date: 2000/12/27 10:45:49$
|   $Author: pb$
|
 ======================================================================"


"======================================================================
|
| Copyright 2001 Free Software Foundation, Inc.
| Written by Dragomir Milevojevic.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 2, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================"

"The regex module is still beta -- expect changes in the interface"

DLD addModule: 'libregex' !

" --- external function definitions --- "

String
	defineCFunc: 'reh_search'
	withSelectorArgs: 'searchRegex: pattern from: from to: to'
	returning: #int
	args: #( self string int int ) 
!

String
	defineCFunc: 'reh_match'
	withSelectorArgs: 'matchRegex: str from: from'
	returning: #int
	args: #( self string int )
!

!String methodsFor: 'regex'!

~ regexString
	^(self searchRegex: regexString from: 1 to: self size) > -1!

indexOfRegex: regexString ifAbsent: excBlock
	| start length |
	start := self searchRegex: regexString from: 1 to: self size.
	start = -1 ifTrue: [ ^excBlock value ].

	length := self matchRegex: regexString from: length.
	^start to: start + length - 1!

!String class methodsFor: 'regex'!

testRegex: qry

	| str res |
	str := 'A quick brown fox jumps over the lazy dog'.

	res := str searchRegex: qry from: 1 to: 25.
	res printNl.

	res := str searchRegex: qry from: (str indexOf: $f) to: 25.
	res printNl.

	res := str matchRegex: qry from: res.
	res printNl.

	res := str matchRegex: qry from: 1.
	res printNl.
! !

" --- TEST --- "

String testRegex: 'f.x'!


